package ab;

import java.io.Reader;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.LowerCaseFilter;
import org.apache.lucene.analysis.Tokenizer;
import org.apache.lucene.analysis.ngram.NGramTokenFilter;
import org.apache.lucene.analysis.ngram.NGramTokenizer;
import org.apache.lucene.analysis.standard.StandardFilter;
import org.apache.lucene.analysis.standard.StandardTokenizer;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.util.Version;

public class NGramAnalyzer extends Analyzer {

	@Override
	public TokenStream tokenStream(String fieldName, Reader reader) {
		
		TokenStream	stream = null;
		Tokenizer tokenizer;
		
		if(fieldName.equals("Annotation")){
			stream = new CustomWhitespaceTokenizer(reader);
			stream = new StandardFilter(stream);
			stream = new BiomedTokenFilter(stream);
			stream = new LowerCaseFilter(stream);
		}
		else if(fieldName.equals("Sequence")){
			tokenizer = new NGramTokenizer(reader, 4, 4);
			stream = new LowerCaseFilter(tokenizer);
		}
		return stream;
	}

}
