package ab;

import java.io.File;
import java.io.IOException;

import javax.swing.DefaultComboBoxModel;
import javax.swing.ListModel;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.Term;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.Searcher;
import org.apache.lucene.search.TermQuery;
import org.apache.lucene.search.TopDocs;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.util.Version;

public class SearchController {
	
	private ListModel resultModel;
	private IndexReader reader;
	MainWindow mainWindow;
	
	public SearchController(MainWindow mainWindow) {
		this.mainWindow = mainWindow; 
	}
	
	public boolean loadIndex(String path){
		boolean status = true;
		try{
			System.out.println(path);
			reader = IndexReader.open(FSDirectory.open(new File(path)), true);;
		}catch(Exception e){
			status = false;
			e.printStackTrace();
		}
		
		return status;
	}
	
	public void standardSearch(String dna) throws IOException{
		// takes in the DNA and uses built in fuzzysearch
		// next, do the serach and return a listmodel
		
		Searcher searcher = new IndexSearcher(reader);
		Analyzer analyzer = new StandardAnalyzer(Version.LUCENE_CURRENT);
		
		Query query = new TermQuery(new Term("Sequence", dna));
		
		TopDocs result = searcher.search(query, null, 10);
		System.out.println("Total hits: " + result.totalHits);
		
		// HEr m det gjres mye mer for  hente ut resultater og slenge dem i resultatlisten
		Document firstHit = searcher.doc(result.scoreDocs[0].doc);
		String temp = firstHit.getField("Annotation").toString();
		String[] tempArray = temp.split("/");
		System.out.println(tempArray[tempArray.length -1].replace(">", ""));
		
		System.out.println(result.scoreDocs[0]);
		
		mainWindow.setResultList(new DefaultComboBoxModel(result.scoreDocs));
	}
	
	public ListModel fuzzyLuceneSearch(String dna){
		// takes in the DNA and uses my fuzzysearch
		// next, do the serach and return a listmodel
		return new DefaultComboBoxModel(new String[]{});
	}
	
	public ListModel fuzzyProfessorSearch(String dna){
		// takes in the DNA and annotaions and uses fuzzysearch
		// next, do the serach and return a listmodel
		return new DefaultComboBoxModel(new String[]{});
	}
	
	public ListModel fuzzyAnnotationSearch(String dna, String annotations){
		// takes in the DNA and annotaions and uses fuzzysearch
		// next, do the serach and return a listmodel
		return new DefaultComboBoxModel(new String[]{});
	}

	public void search() {
		
	}
	
}